unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  ACollCount = 100000;

type

  { TFixCollection - fix TCollection.RemoveItem bug in Delphi 3,4,5 }

  TFixCollection = class(TCollection)
  public
    { Unfortunately Clear is not a virtual or dynamic procedure so we will have to reintroduce it }
    procedure Clear;
    destructor Destroy; override;
  end;

  procedure TFixCollection.Clear;
  var
    i: integer;
    AList, OrgList: TList;
  begin
    AList := TList.Create;
    try
      OrgList := TList(PDWORD(DWORD(Self) + $4 + SizeOf(TPersistent))^);

      { Save original pointers to collection items }
      for i := 0 to OrgList.Count-1
        do AList.Add(OrgList[i]);

      OrgList.Clear;

      { Destroy collection items }
      for i := 0 to AList.Count-1
        do TCollectionItem(AList[i]).Free;
    finally
      AList.Free;
    end;
    inherited;
  end;

  destructor TFixCollection.Destroy;
  begin
    Clear;
    inherited;
  end;



procedure TForm1.Button1Click(Sender: TObject);
var
  old: TCollection;
  i: integer;
begin
  old := TCollection.Create(TCollectionItem);
  for i := 0 to 100000
    do old.Add;
  Windows.beep(900, 1000); // hi-freq beep after we done with adding empty items
  old.Free;
  Windows.beep(100, 1000);// low-freq beep after we done with destroying empty items
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  old: TFixCollection;
  i: integer;
begin
  old := TFixCollection.Create(TCollectionItem);
  for i := 0 to 100000
    do old.Add;
  Windows.beep(900, 1000); // hi-freq beep after we done with adding empty items
  old.Free;
  Windows.beep(100, 1000);// low-freq beep after we done with destroying empty items
end;

end.
